<?php
namespace Controllers;

use \Zeedhi\Framework\Report\ReportService;
use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use \Zeedhi\Framework\DTO\Request\Row;

class FichaTecnicaReport extends \Zeedhi\Framework\Controller\Report {

    protected $environment;
    protected $crudService;
    protected $dataSourceManager;
    protected $birtStrategy;

    public function __construct(ReportService $reportService, $environment, $crudService, $dataSourceManager, $birtStrategy) {
        $this->crudService = $crudService;
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->birtStrategy = $birtStrategy;
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'COC01200' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
              "CDFILIAL"        => "CDFILIAL",
              "CDCIA"           => "CDCIA",
              "CDMANCIA"        => "CDMANCIA",
              "CDCICLO"         => "CDCICLO",
              "NRORG"           => "NRORG",
              "FILESERVPATH"    => "FILESERVPATH",
              "SERVCLASSE"      => "SERVCLASSE",
              "SUBGRUPO"        => "SUBGRUPO",
              "DATAREF"         => "DATAREF",
              "DESTREF"         => "DESTREF",
              "VOOREF"          => "VOOREF",
              "HIDEIMG"         => "HIDEIMG",
              "HIDECOMP"        => "HIDECOMP",
              "HIDEMODPREP"     => "HIDEMODPREP",
              "CDSETOR"         => "CDSETOR",
              "ONLYVIGSBG"      => "ONLYVIGSBG"
            ),
            'reportName'
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
      $row = $request->getRow();
      if (isset($row['__locale']) && $row['__locale']){
        $this->birtStrategy->setReportLocale($row['__locale']);
      }
      $row['__report_name'] = 'COC01200';
      $row['NRORG'] = $this->environment->getNrOrgTrab();
      $row['DATAREF'] = $this->environment->getCurrentTime()->format("d/m/Y");
    }
}