<?php

namespace Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class ListagemTabelaPrecos extends \Zeedhi\Framework\Controller\Report {

  protected $environment;
  protected $birtStrategy;
  protected $util;
  protected $crudService;

  public function __construct(ReportService $reportService, $birtStrategy, $environment, $util, $crudService) {
      $this->birtStrategy = $birtStrategy;
      $this->environment = $environment;
      parent::__construct($reportService);
      $this->util = $util;
      $this->crudService = $crudService;
  }

  protected $reportMapping = array (
    'COC21002' =>
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "NRLISTA"          => "NRLISTA",
        "CDCIA"            => "CDCIA",
        "IDVIGENCIA"       => "IDVIGENCIA",
        "NRORG"            => "NRORG",
        "CDFILIALLOGO"     => "CDFILIALLOGO"
      ),
      'reportName'
    ),
    'COC21003' =>
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "NRLISTA"          => "NRLISTA",
        "CDCIA"            => "CDCIA",
        "IDVIGENCIA"       => "IDVIGENCIA",
        "NRORG"            => "NRORG",
        "DATAINI"          => "DATAINI",
        "DATAFIN"          => "DATAFIN",
        "STATUS"           => "STATUS",
        "CDFILIALLOGO"     => "CDFILIALLOGO"
      ),
      'reportName'
    ),
    'COC21004' =>
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILIAL"              => "CDFILIAL",
        "CDCIA"                 => "CDCIA",
        "NRTABPRECO"            => "NRTABPRECO",
        "NRORG"                 => "NRORG",
        "NRSERVICOCIAFILIPRECO" => "NRSERVICOCIAFILIPRECO",
        "CDCLASSE"              => "CDCLASSE",
        "CDCICLO"               => "CDCICLO",
        "DTREFERENCIA"          => "DTREFERENCIA",
        "SOMENTE_VIGENTES"      => "SOMENTE_VIGENTES"
      ),
      'reportName'
    ),
    'COC21005' =>
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILIAL"              => "CDFILIAL",
        "CDCIA"                 => "CDCIA",
        "NRTABPRECO"            => "NRTABPRECO",
        "NRORG"                 => "NRORG",
        "NRSERVICOCIAFILIPRECO" => "NRSERVICOCIAFILIPRECO",
        "CDCLASSE"              => "CDCLASSE",
        "CDCICLO"               => "CDCICLO",
        "DTREFERENCIA"          => "DTREFERENCIA",
        "SOMENTE_VIGENTES"      => "SOMENTE_VIGENTES"
      ),
      'reportName'
    ),
    'COC21006' =>
    array (
      'strategy' => 'BIRT',
      'parameterMapping' =>
      array (
        "CDFILIAL"              => "CDFILIAL",
        "CDCIA"                 => "CDCIA",
        "NRTABPRECO"            => "NRTABPRECO",
        "NRORG"                 => "NRORG",
        "NRSERVICOCIAFILIPRECO" => "NRSERVICOCIAFILIPRECO",
        "CDCLASSE"              => "CDCLASSE",
        "CDCICLO"               => "CDCICLO",
        "DTREFERENCIA"          => "DTREFERENCIA",
        "SOMENTE_VIGENTES"      => "SOMENTE_VIGENTES",
        "EXIB_PRECO_PROP"       => "EXIB_PRECO_PROP"
      ),
      'reportName'
    )
  );

  public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
    $row = $request->getRow();
    if($row['REPORTNAME'] === 'COC21002' || $row['REPORTNAME'] === 'COC21003') {
      if($row['CDFILIAL'] === 'T') {
        $params = array(
          array(
                  "columnName" => 'CDOPERADOR',
                  "operator"   => '=',
                  "value"      => $this->environment->getCdoperador()
          )
        );
        $units = $this->crudService->getFilteredDataSet('filial_filioper', $params)->getRows();
        $codUnit = [];
        foreach($units as $unit) {
          array_push($codUnit, $unit['CDFILIAL']);
        }
        $row['CDFILIAL'] = $codUnit;
        $row['CDFILIALLOGO'] = $this->environment->getCdFilial();
      } else if(count($row['CDFILIAL']) === 1){
        $row['CDFILIALLOGO'] = $row['CDFILIAL'][0];
      } else {
         $row['CDFILIALLOGO'] = $this->environment->getCdFilial();
      }
      $row['NRLISTA'] = $this->util->insertLista($row['CDFILIAL']);
    }
    $row['__report_name'] = $row['REPORTNAME'];
    $this->birtStrategy->setReportFormat($row['REPORTFORMAT']);
    $row['NRORG'] = $this->environment->getNrOrgTrab();
  }
  
}